----------------
--- Schritt 2
----------------
insert into w (wid, it, sl, sw, pl, pw)
select wid, XXX as it, sl, sw, pl, pw
from (
select d.wid,
avg(sepallength) as sl, avg(sepalwidth) as sw, avg(petallength) as pl, avg(petalwidth) as pw
from ( select b.pid, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                sqrt((i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw)) as dist
             from iris i,w
             where it=XXX-1
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                sqrt((i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw)) as dist
            from iris i,w
           where it=XXX-1
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid
     )d, iris i
where d.pid = i.pid
group by d.wid
);

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=XXX
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=XXX
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=XXX;
