----------------
--- Schritt 2
----------------
insert into w (wid, it, sl, sw, pl, pw)
select wid, XXX as it, sl, sw, pl, pw
from (
select d.wid,
avg(sepallength) as sl, avg(sepalwidth) as sw, avg(petallength) as pl, avg(petalwidth) as pw
from ( select b.pid, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                sqrt((i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw)) as dist
             from iris i,w
             where it=XXX-1
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                sqrt((i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw)) as dist
            from iris i,w
           where it=XXX-1
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid
     )d, iris i
where d.pid = i.pid
group by d.wid
);

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=XXX
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=XXX
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=XXX;

-------------------------------
-- Verschiebe Repraesentanten
-------------------------------
update w w1
set (sl,sw,pl,pw)=
(
select
sl + ((select (max(i.sepallength)-min(i.sepallength))/50 from iris i) * dbms_random.value(-1,1)),
sw + ((select (max(i.sepalwidth)-min(i.sepalwidth))/50 from iris i)* dbms_random.value(-1,1)),
pl + ((select (max(i.petallength)-min(i.petallength))/50 from iris i)* dbms_random.value(-1,1)),
pw + ((select (max(i.petalwidth)-min(i.petalwidth))/50 from iris i)* dbms_random.value(-1,1))
from w
where it=XXX and
      q_error=(select max(q_error) from w where it=XXX )
)
where (w1.anzahl<3 or w1.anzahl is null) and w1.it=XXX;

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=XXX
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=XXX
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=XXX;
